<template>

	<div class="flex">
		<AppBreadcrumb :value="breadcrumb" v-if="!loading" />
		<div class="flex-1">&nbsp;</div>
	</div>

	<!-- If the user reached an invalid product page (eg, an old URL), show the user a warning message -->
	<div v-if="!loading && product == null" class="banner banner-warning">
		<div class="banner-title">This product is no longer available.</div>
		<div class="banner-subtitle">Click <router-link to="/" class="font-semibold link">here</router-link> to view all our products.</div>
	</div>

	<div v-else class="my-4 md:my-8 flex flex-col md:flex-row">
		
		<div class="md:w-1/4 lg:h-96 h-80 mx-auto">

			<!-- Product image -->
			<img v-if="!loading" :src="product.image" alt="Product image" class="max-w-full max-h-full md:py-4 mx-auto" />
			<div class="skeleton-loader h-64 w-64 max-w-full max-h-full" v-if="loading"></div>

		</div>

		<div class="md:w-3/4 md:pl-8 lg:pl-16 text-center md:text-left">

			<!-- Product header -->
			<div class="flex flex-col sm:flex-row mt-2 items-center">
					
				<!-- Product title -->
				<div class="text-xl font-medium">
					<div v-if="!loading">{{ product.title }}</div>
					<div v-if="loading">
						<div class="skeleton-loader w-24 h-8"></div>
						<div class="skeleton-loader w-64 ml-0.5 h-8"></div>
						<div class="skeleton-loader w-36 ml-0.5 h-8"></div>
					</div>
				</div>

				<div class="flex-1">&nbsp;</div>

				<!-- Product price -->
				<div class="font-semibold w-32 text-right self-end sm:self-center">
					<div v-if="!loading">
						{{ product.price.toFixed(2) }}<span class="ml-0.5 text-sm align-top">€</span>
					</div>
					<div class="skeleton-loader w-16 h-6" v-if="loading">
						&nbsp;
					</div>
				</div>

			</div>

			<!-- Product description -->
			<div class="font-light mt-4">
				<div v-if="!loading" class="text-justify">{{ product.description }}</div>
				<div v-if="loading">
					<div class="skeleton-loader-sm w-full">&nbsp;</div>
					<div class="skeleton-loader-sm w-full">&nbsp;</div>
					<div class="skeleton-loader-sm w-3/4">&nbsp;</div>
					<div class="skeleton-loader-sm w-1/4">&nbsp;</div>
					<div class="skeleton-loader-sm w-full">&nbsp;</div>
					<div class="skeleton-loader-sm w-2/4">&nbsp;</div>
					<div class="skeleton-loader-sm w-2/4">&nbsp;</div>
				</div>
			</div>

		</div>

	</div>

</template>

<script>

import categoriesService from '../services/categories-service';
import productsService from '../services/products-service';

import AppBreadcrumb from '../components/AppBreadcrumb.vue';

/**
 * Simple page responsible of showing product details.
 * In the future, if more functionalities are added to this page, it would make sense to move the product details to its own component.
 */
export default {
	data() {
		return {
			loading: true,
			product: null,
			category: null,
		};
	},
	created() {
		this.fetchDetails( this.$route.params.productId );
	},
	computed: {
		breadcrumb() {
			if ( this.product ) {
				return [ 
					{ name: this.category.name, url: `/categories/${this.category.slug}` },
					// { name: this.product.title, url: this.$route.path } // Unfortunately putting the product name in the breadcrumb creates duplication at the top of the page
					{ name: 'Product details', url: this.$route.path }
				];
			} else {
				return [ 
					{ name: 'Unknown product', url: this.$route.path }
				];
			}
		}
	},
	methods: {
		async fetchDetails( productId ) {
			this.loading = true;

			// Get this product details.
			this.product = await productsService.getProductById( productId ).catch( err => {
				console.error( `An error occured while retrieving product ${productId}`, err );
				return null;
			});

			// Get this product category.
			if ( this.product ) {
				const allCategories = await categoriesService.getAllCategories();
				this.category = allCategories.find( cat => cat.id === this.product.category ); 
				// Note: Here we assume that the category exists, but assuming that categories are retrieved from the same backend as the products,
				// this would be always the case. 
			}

			this.loading = false;
		}
	},
	components: {
		AppBreadcrumb
	}	
}
</script>
